;	  RDA5807M					;
;	  4 				;
;-------RDA----------------------------------
TUNE_En		EQU			4					;
;--------LCD----------------------------
#DEFINE		rset		PORTA,1				;	reset
#DEFINE		enab		PORTA,0				;	ce
#DEFINE		dorc		PORTA,2				;	dc
#DEFINE		sdta		PORTA,3				;	din
#DEFINE		sclk		PORTA,4				;	clk
;--------I2C----------------------------
#DEFINE		SCL			PORTB,7				;	Broche 'Serial CLock' du bus I2C.
#DEFINE		SDA			PORTB,6				;	Broche 'Serial DAta' du bus I2C.
#DEFINE		TRISA_SDA	PORTB,6				;
;--------------------------------------
#DEFINE		VOL_P		PORTB,0				;
#DEFINE		VOL_M		PORTB,1				;
#DEFINE		FREQ_P		PORTB,2				;
#DEFINE		AVTO_S		PORTB,3				;
;--------------------------------------------
WRITE_ADDR			equ		0x20			;
WRITE_ADDR_FREQ		equ		0x22			;
READ_ADDR_avtoscan	equ		0x23			;
;WRITE_ADDR1	equ		b'10100001'				;
;--------------------------------------------
											;
;;; BOOLEEN :								;
I2CACK		equ		0						;	le bit '0' de l'adresse BOOLEEN, qui sert a
;=======================================
			Cblock		0x23				;
;--------------------------------------------
DebutRAM									;
BOOLEEN 									; 	8 bits = 8 variables booleennes.
I2C_data									;	Octet de donnee.
I2C_adrHIGH									;	Adresse : octet de poids faible.
I2C_adrLOW									;	Adresse : octet de poids fort.
VAR1										;	3 variables temporaires :
VAR2										;	sauvegarde de W, compteurs, etc.
LSB											;
MSB											;
;----LCD-----------------------------
count1										;
count2										;
count3										;
count4										;
afisaj										;
xini										;
Temp_ind									;
;--------------------------------------------
Frequency									;
Freq1										;
Freq_H_ind									;
Freq_L_ind									;
;--- 2/10 -------------
BSDH										;
BSDL										;
Thou										;
Hund										;
TenK										;
Tens										;
Ones										;
;--------------------------------------------
TEMP										;
TEMP_1										;
TEMP_2										;
;--------------------------------------------
REG_2H										;
REG_2L										;
REG_3H										;
REG_3L										;
REG_4H										;
REG_4L										;
REG_5H										;
REG_5L										;
											;
REG_0A_H									;
REG_0A_L									;
REG_0B_H									;
REG_0B_L									;
											;
REG_RDSA_H									;
REG_RDSA_L									;
REG_RDSB_H									;
REG_RDSB_L									;
REG_RDSC_H									;
REG_RDSC_L									;
REG_RDSD_H									;
REG_RDSD_L									;
											;
RDS_TEXT_1									;
RDS_TEXT_2									;
RDS_TEXT_3									;
RDS_TEXT_4									;
RDS_TEXT_5									;
RDS_TEXT_6									;
RDS_TEXT_7									;
RDS_TEXT_8									;
;--------------------------------------------
FLAG_RDS									;
;--------------------------------------------
TAIM_H										;
TAIM_L										;
;--------------------------------------------
			endc							;
;--------------------------------------------
;---*EEPROM--------------------------
Temp_ADDR	equ			0x70				;
Temp_EEDAT	equ			0x71				;
;************************************************************
			list		p = 16f88			;
			#include	<p16f88.inc>		;
											;
			__CONFIG	_CONFIG1, _CP_OFF & _DEBUG_OFF & _WRT_PROTECT_ALL & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO ;_XT_OSC	;
			__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF	;
											;
			errorlevel -302,-306			;
;--------------------------------------------
			org	2100h						;  ;
			DE	0xD2,0x0D,0x23,0x10,0x02,0x00,0x88,0x88; (REG_2H,REG_2L,REG_3H,REG_3L,REG_4H,REG_4L,REG_5H,REG_5L)
			DE	0x8C						; () 
;-------------------------------------------- 
			ORG			0h					;     0-  PC.
			goto		START				;
;************************************************************
;************************************************************
Privet_text									;
			addwf		PCL,f				;
			dt	0x7F,0x01,0x01,0x01,0x7F,0x00 	; 
			dt	0x7F,0x09,0x09,0x09,0x06,0x00	; 
			dt	0x7F,0x10,0x08,0x04,0x7F,0x00 	; 
			dt	0x7F,0x49,0x49,0x49,0x36,0x00	; 
			dt	0x7F,0x49,0x49,0x49,0x49,0x00	; 
			dt	0x01,0x01,0x7F,0x01,0x01,0x00	;  
;--------------------------------------------
FM_Text										;
			addwf		PCL,f				;
			DT	0x00,0xFE,0x04,0x18,0x04,0xFE	; M
			DT	0x00,0xF8,0x08,0x08,0x08,0x08	; 
			DT	0x00,0x78,0x40,0x40,0x78,0xC0	; 
;--------------------------------------------
FM_Radio									;
			addwf		PCL,f      			;
			DT	0x7F,0x09,0x09,0x09,0x01,0x00	; F
			DT	0x7F,0x02,0x0C,0x02,0x7F,0x00	; M
			DT	0x00,0x00,0x00,0x00,0x00,0x00	; 
			DT	0x7F,0x09,0x09,0x09,0x06,0x00	; 
			DT	0x20,0x54,0x54,0x54,0x78,0x00	; 
			DT	0x60,0x3C,0x24,0x3C,0x60,0x00	; 
			DT	0x7C,0x20,0x10,0x08,0x7C,0x00	; 
			DT	0x38,0x44,0x44,0x44,0x38,0x00	; 
;--------------------------------------------
Vol											;
			addwf		PCL,f				;
			DT	0x00,0x7F,0x22,0x1C,0x1C,0x00	;
			DT	0x00,0x1C,0x1C,0x22,0x7F,0x00	; 
;--------------------------------------------
Seg_ant										;
			addwf		PCL,f				;
			DT	0x40,0x00,0x60,0x00,0x70,0x00,0x78,0x00,0x7C,0x00,0x7E,0x00,0x7F ;
;--------------------------------------------
POK_antena									;
			addwf		PCL,f				;
			DT	0x02,0x06,0x0A,0x7E,0x0A,0x06,0x02,0x00;
;************************************************************
START										;
			clrf		PORTA				;
			clrf		PORTB				;
			clrf		FLAG_RDS			;
			clrf		Temp_ADDR			;
											;
			bsf			STATUS,RP0			;   1- .
			movlw		b'01101110'			;
			movwf		OSCCON				;
			movlw		b'00000111'			; 
			movwf		CMCON				; .
			movlw		0x00				;
			movwf		ANSEL				;
			movlw		b'00000000'			;
			movwf		TRISA				;   
			movlw		b'00111111'			;
			movwf		TRISB				;
			movlw		b'00000000' 		;   , 
			movwf		OPTION_REG			;   Tmr0 1:2
			movlw		b'00000000'			;  
			movwf		INTCON				;   
			bcf			STATUS,RP0			;   0- .
;--------------------------------------------
			BSF			SCL					;
			BSF			SDA					;
			CLRF		BOOLEEN				;
			movlw		b'00110000'			; 
			movwf		T1CON				;  1
;-------***EEprom----------
			call		EERED				;    EEPROM
			movwf		REG_2H				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		REG_2L				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		REG_3H				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		REG_3L				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		REG_4H				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		REG_4L				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		REG_5H				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		REG_5L				;
			incf		Temp_ADDR,f			;
			call		EERED				;    EEPROM
			movwf		Frequency			; 
;--------------------------------------------
			call		LCD_INIT			;
;--------------------------------------------
			call		PRIVETSTVIE			;
											;
			call		Eresh_LCD			;
											;
			call		WRIT_RDA5807		;
;--------------------------------------------
			call		lin1				;
			call		poz0				;
											;
			movlw		.8					;
			movwf		Temp_ind			;
 			movf		Temp_ind,W			;  SIM_antena 
			sublw		.8					;
			call		POK_antena			;
			call		lcdta				;
			decfsz		Temp_ind,F			;
			goto		$-5					;
											;
			call		lin1				;
			call		poz7				;
											;
			movlw		.12					;
			movwf		Temp_ind			;
			movf		Temp_ind,W			;  Vol 
			sublw		.12					;
			call		Vol					;
			call		lcdta				;
			decfsz		Temp_ind,F			;
			goto		$-5					;
											;
			call		lin2				;
			call		poz3				;
											;
			movlw		.48					;
			movwf		Temp_ind			;
			movf		Temp_ind,W			;  FM_Radio 
			sublw		.48					;
			call		FM_Radio			;
			call		lcdta				;
			decfsz		Temp_ind,F			;
			goto		$-5					;
											;
			call		lin4				;
			call		poz11				;
											;
			movlw		.18					;
			movwf		Temp_ind			;
			movf		Temp_ind,W			;  FM_Text 
			sublw		.18					;
			call		FM_Text				;
			call		lcdta				;
			decfsz		Temp_ind,F			;
			goto		$-5					;
;--------------------------------------------
			call		POK_GROM			;
			call		INDIK_FREQ_med		;
;--------------------------------------------
MAIN										;
			btfss		VOL_P				;
			call		VOL_PLUS			;
			btfss		VOL_M				;
			call		VOL_MINUS			;
			btfss		FREQ_P				;
			call		FREQ_PLUS			;
			btfss		AVTO_S				;
			call		AVTO_SCAN			;
											;
		;	call		RED_RDA5807			;
		;	call		POK_UR_SIGNAL		;
			call		RDS					;
											;
			goto		MAIN				;
;-----------*--------------------------------
AVTO_SCAN									;
			btfss		AVTO_S				;
			goto		$-1					;
START_avtoscan								;
			call		WRIT_AVTOSCAN		;
R_A											;
			call		delay_100ms			;
											;
			call		RED_RDA5807			;
											;
			movfw		REG_0A_L			;
			movwf		Frequency			;
											;
			call		preob_FREQ			;
											;
			call		INDIK_FREQ_med		;
											;
			btfss		REG_0A_H,6			;
			goto		R_A					;
											;
			movf		REG_0A_L,w			;
			sublw		0xD2				;
			btfsc		STATUS,Z			;
			clrf		REG_0A_L			;
											;
			movfw		REG_0A_L			;
			movwf		Frequency			;
											;
			call		preob_FREQ			;
											;
			btfss		REG_0B_H,0			;
			goto		START_avtoscan		;
											;
			return							;
;--------------------------------------------
RDS											;
			call		RED_RDA5807_1		;
											;
			call		POK_UR_SIGNAL		;
											;
			btfss		REG_0A_H,4			;
			call		ERESH_RDS			;
RDS_2										;
			movf		REG_0B_L,w			;
			andlw		b'00001111'			;
			movwf		TEMP_1				;
											;
			movf		TEMP_1,w			;
			btfss		STATUS,Z			;
			return							;
											;
			movf		REG_RDSB_H,w		;
			andlw		b'11110000'			;
			movwf		REG_RDSB_H			;
											;
			movf		REG_RDSB_H,w		;
			sublw		0x00				;
			btfss		STATUS,Z			;
			return							;
											;
			movf		REG_RDSB_L,w		;
			andlw		b'00000011'			;
			movwf		REG_RDSB_L			;
											;
			movf		REG_RDSB_L,w		;
			sublw		b'00000011'			;
			btfsc		STATUS,Z			;
			goto		SIM_4				;
											;
			movf		REG_RDSB_L,w		;
			sublw		b'00000010'			;
			btfsc		STATUS,Z			;
			goto		SIM_3				;
											;
			movf		REG_RDSB_L,w		;
			sublw		b'00000001'			;
			btfsc		STATUS,Z			;
			goto		SIM_2				;
											;
			movf		REG_RDSB_L,w		;
			sublw		b'00000000'			;
			btfsc		STATUS,Z			;
			goto		SIM_1				;
			return							;
SIM_1										;
			btfsc		FLAG_RDS,0			;
			return							;
			movf		REG_RDSD_H,w		;
			movwf		RDS_TEXT_1			;
			movf		REG_RDSD_L,w		;
			movwf		RDS_TEXT_2			;
			bsf			FLAG_RDS,0			;
			goto		PRINT_RDS			;
SIM_2										;
			btfsc		FLAG_RDS,1			;
			return							;
			movf		REG_RDSD_H,w		;
			movwf		RDS_TEXT_3			;
			movf		REG_RDSD_L,w		;
			movwf		RDS_TEXT_4			;
			bsf			FLAG_RDS,1			;
			goto		PRINT_RDS			;
SIM_3										;
			btfsc		FLAG_RDS,2			;
			return							;
			movf		REG_RDSD_H,w		;
			movwf		RDS_TEXT_5			;
			movf		REG_RDSD_L,w		;
			movwf		RDS_TEXT_6			;
			bsf			FLAG_RDS,2			;
			goto		PRINT_RDS			;
SIM_4										;
			btfsc		FLAG_RDS,3			;
			return							;
			movf		REG_RDSD_H,w		;
			movwf		RDS_TEXT_7			;
			movf		REG_RDSD_L,w		;
			movwf		RDS_TEXT_8			;
			bsf			FLAG_RDS,3			;
			goto		PRINT_RDS			;
;-----------------------
PRINT_RDS									;
			movf		FLAG_RDS,w			;
			sublw		b'00001111'			;
			btfss		STATUS,Z			;
			return							;
			call		lin6				;
			call		poz4				;
			movf		RDS_TEXT_1,w		;
			call		POC_ASCII			;
			movf		RDS_TEXT_2,w		;
			call		POC_ASCII			;
			movf		RDS_TEXT_3,w		;
			call		POC_ASCII			;
			movf		RDS_TEXT_4,w		;
			call		POC_ASCII			;
			movf		RDS_TEXT_5,w		;
			call		POC_ASCII			;
			movf		RDS_TEXT_6,w		;
			call		POC_ASCII			;
			movf		RDS_TEXT_7,w		;
			call		POC_ASCII			;
			movf		RDS_TEXT_8,w		;
			call		POC_ASCII			;
											;
			clrf		FLAG_RDS			;
			return							;
;-----------------------
ERESH_RDS									;
			call		lin6				;
			call		poz4				;
			movlw		0x30				;
			movwf		TEMP_2				;
			movlw		0x00				;
			call		lcdta				;
			decfsz		TEMP_2,f			;
			goto		$-3					;
			return							;
;-----------**--------------------------------
FREQ_PLUS									;			
			incf		Frequency,f			;
			movf		Frequency,w			;
			sublw		0xD3				;
			btfsc		STATUS,Z			;
			clrf		Frequency			;
			call		preob_FREQ			;
			call		WRIT_FREQ			;
			call		INDIK_FREQ_med		;
			call		delay_100ms			;
			call		delay_100ms			;
			return							;
;-----------**------------------------------
;-----------*-------------------
VOL_PLUS									;
			movf		REG_5L,w			;
			andlw		b'00001111'			;
			movwf		TEMP				;
			incf		TEMP,F				;
			movf		TEMP,w				;
			sublw		0x10				;
			btfsc		STATUS,Z			;	
			decf		TEMP,f				;
			movf		TEMP,w				;
			xorlw		b'10100000'			;
			movwf		REG_5L				;
			call		WRIT_VOL			;
			call		POK_GROM			;
			btfss		VOL_P				;
			goto		$-1					;
			return							;
;-----------*------------------
VOL_MINUS									;
			movf		REG_5L,w			;
			andlw		b'00001111'			;
			movwf		TEMP				;
			decf		TEMP,F				;
			movf		TEMP,w				;
			sublw		0xFF				;
			btfsc		STATUS,Z			;
			clrf		TEMP				;
			movf		TEMP,w				;
			xorlw		b'10100000'			;
			movwf		REG_5L				;
			call		WRIT_VOL			;
			call		POK_GROM			;
			btfss		VOL_M				;
			goto		$-1					;
			return							;
;----------**------
POK_GROM									;
			call		lin1				;
			call		poz10				;
											;
			movf		REG_5L,w			;
			andlw		b'00001111'			;
			movwf		Temp_ind			;
			movlw		.15					;
			movwf		TEMP				;
											;
			movlw		0x7E				;
			call		lcdta				;
											;
			movf		Temp_ind,W			; 
			btfsc		STATUS,Z			;
			goto		POK_GROM_1			;
											;
			movlw		0x7E				;
			call		lcdta				;
			decf		TEMP,f				;
			decfsz		Temp_ind,F			;
			goto		$-4					;
POK_GROM_1									;
			movf		TEMP,W				; 
			btfsc		STATUS,Z			;
			return							;
			movlw		0x42				;
			call		lcdta				;
			decfsz		TEMP,F				;
			goto		$-3					;
			movlw		0x7E				;
			call		lcdta				;
			return							;
;---------*-------------
preob_FREQ									;
			movfw		Frequency			;
			movwf		REG_3H				;
			clrf		REG_3L				;
											;
			bcf			STATUS,C			;
											;
			rrf			REG_3H,f			;
			rrf			REG_3L,f			;
			rrf			REG_3H,f			;
			rrf			REG_3L,f			;
											;
			bsf			REG_3L,TUNE_En		;
			return							;
;---------***---
POD_IND_Freq								;
			clrf		Freq1				;
			movlw		0x03				;
			movwf		Freq_H_ind			;
			movlw		0x66				;
			movwf		Freq_L_ind			;
											;
			movf		Frequency,W			;
			addwf		Freq_L_ind,F		;
			btfsc		STATUS,C			;
			incf		Freq_H_ind,F		;
			movf		Freq1,W				;
			addwf		Freq_H_ind,F		;
			return							;
;--------------------------------------------
INDIK_FREQ_med								;
			call		POD_IND_Freq		;											;
			movfw		Freq_H_ind			;
			movwf		BSDH				;
			movfw 		Freq_L_ind			;
			movwf		BSDL				;
											;
			call		BINToBCD16_5		;
;------------------------
			call		lin3				;
			call		poz1				;
											;
			movf 		Thou,w				;     
			btfss		STATUS,Z			;
			goto		POK_Thou_med		;     
											;
			movlw		.12 				;
			movwf		Temp_ind			;
			movlw		0x00				;
			call		lcdta				;
			decfsz		Temp_ind,f			;
			goto		$-3					;
											;
			call		lin4				;
			call		poz1				;
											;
			movlw		.12					;
			movwf		Temp_ind			;
			movlw		0x00				;
			call		lcdta				;
			decfsz		Temp_ind,f			;
			goto		$-3					;
			goto		POK_Hund_med		;
;-----------**---------
POK_Thou_med								;
			movfw		Thou				;
			movwf		TEMP_1				;
											;
			call		IND_VERX			;
											;
			call		lin4				;
			call		poz1				;
											;
			call		IND_NIZ				;
;-----------**-------
POK_Hund_med								;
			call		lin3				;
			call		poz3				;
											;
			movfw		Hund				;
			movwf		TEMP_1				;
											;
			call		IND_VERX			;
											;
			call		lin4				;
			call		poz3				;
											;
			call		IND_NIZ				;
;-----------**-------
			call		lin3				;
			call		poz5				;
											;
			movfw		Tens				;
			movwf		TEMP_1				;
											;
			call		IND_VERX			;
											;
			call		lin4				;
			call		poz5				;
											;
			call		IND_NIZ				;
;-----------*--------------------
			call		lin4				;
			call		poz8				;
											;
			movlw		.10					;
			movwf		TEMP_1				;
											;
			call		POC_SIMVOL			;
;-----------**----------
			call		lin3				;
			call		poz9				;
											;
			movfw		Ones				;
			movwf		TEMP_1				;
											;
			call		IND_VERX			;
											;
			call		lin4				;
			call		poz9				;
											;
			call		IND_NIZ				;		
											;
			return							;
;-----------------
IND_VERX									;
			clrf		PCLATH				;
			movlw		.12					;
			movwf		Temp_ind			;
			movlw		HIGH Cifra_med		;
			movwf		PCLATH				;
			movf		Temp_ind,w			;
			sublw		.12					;
			movwf		TEMP				;
			movf		TEMP_1,w			;
			call		Cifra_med			;
			clrf		PCLATH				;
			call		lcdta				;
			decfsz		Temp_ind,f			;
			goto		$-.10				;
			return							;
;-----------------
IND_NIZ										;
			movlw		.12					;
			movwf		Temp_ind			;
			movlw		HIGH Cifra_med		;
			movwf		PCLATH				;
			movf		Temp_ind,w			;
			sublw		.24					;
			movwf		TEMP				;
			movf		TEMP_1,w			;
			call		Cifra_med			;
			clrf		PCLATH				;
			call		lcdta				;
			decfsz		Temp_ind,f			;
			goto		$-.10				;
			return							;
;--------------------------------------------
POK_UR_SIGNAL								;
			movf		REG_0B_H,w			;
			movwf		TEMP				;
											;
			bcf			STATUS,C			;
											;
			rrf			TEMP,f				;
			movfw		TEMP				;
			movwf		TEMP_2				;
											;
			movf		TEMP,w				;
			sublw		0x7F				;
			btfsc		STATUS,C			;
			goto		$+4					;
			movlw		.13					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;
											;
			movf		TEMP,w				;
			sublw		0x6D				;
			btfsc		STATUS,C			;
			goto		$+4					;
			movlw		.12					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;
											;
			movf		TEMP,w				;
			sublw		0x5B				;
			btfsc		STATUS,C			;
			goto		$+4					;
			movlw		.10					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;
											;
			movf		TEMP,w				;
			sublw		0x49				;
			btfsc		STATUS,C			;
			goto		$+4					;
			movlw		.8					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;
											;
			movf		TEMP,w				;
			sublw		0x37				;
			btfsc		STATUS,C			;
			goto		$+4					;
			movlw		.6					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;
											;
			movf		TEMP,w				;
			sublw		0x25				;
			btfsc		STATUS,C			;
			goto		$+4					;
			movlw		.4					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;
											;
			movf		TEMP,w				;
			sublw		0x13				;
			btfsc		STATUS,C			;
			goto		$+4					;
			movlw		.2					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;
											;
			movf		TEMP,w				;
			btfsc		STATUS,Z			;
			goto		$+4					;
			movlw		.2					;
			movwf		TEMP_1				;
			goto		POK_UR_ANT			;	
			clrf		TEMP_1				;
POK_UR_ANT									;
			call		lin1				;
			movlw		0x87				; punct
			call		lccmd				;
											;
			movf		TEMP_1,W			; 
			btfsc		STATUS,Z			;
			goto		POK_UR_ANT_1		;
											;
			movlw		.13					;
			movwf		TEMP				;
			movlw		.13					;
			movwf		Temp_ind			;
											;
			movf		Temp_ind,W			;
			sublw		.13					;
			call		Seg_ant				;
			call		lcdta				;
			decf		Temp_ind,f			;
			decf		TEMP,f				;
			decfsz		TEMP_1,F			;
			goto		$-7					;
POK_UR_ANT_1								;
			movf		TEMP,W				; 
			btfsc		STATUS,Z			;
			goto		POK_VEL_SIGNAL		;
			movlw		0x00				;
			call		lcdta				;
			decfsz		TEMP,F				;
			goto		$-3					;
POK_VEL_SIGNAL								;
			movfw		TEMP_2				;
			movwf		BSDL				;
			clrf		BSDH				;
											;
			call		BINToBCD16_5		;
											;
			call		lin1				;
			call		poz4				;
											;
			movf		Hund,w				;
			call		POC_SIMVOL			;
											;
			movf		Tens,w				;		
			call		POC_SIMVOL			;
											;
			movf		Ones,w				;	
			call		POC_SIMVOL			;
											;
			return							;
;--------------------------------------------
PRIVETSTVIE									;
											;
			call		lin3				;
			call		poz4				;
											;
			call		Privet				;
											;
			call		delay_500ms			;
			call		delay_500ms			;
											;
			return							;
;--------------------------------------------
POC_SIMVOL									;
			movwf		TEMP_1				;
			clrf		PCLATH				;
			movlw		.6					;
			movwf		Temp_ind			;
			movlw		HIGH Cifra			;
			movwf		PCLATH				;
			movf		Temp_ind,w			;
			sublw		.6					;
			movwf		TEMP				;
			movf		TEMP_1,w			;
			call		Cifra				;
			clrf		PCLATH				;
			call		lcdta				;
			decfsz		Temp_ind,f			;
			goto		$-.10				;
			return							;
;--------------------------------------------
POC_ASCII									;
			movwf		TEMP_1				;
											;
			movf		TEMP_1,w			;
			sublw		0x1F				;
			btfsc		STATUS,C			;
			return							;
											;
			movf		TEMP_1,w			;
			sublw		0x7F				;
			btfss		STATUS,C			;
			return							;
											;
			movlw		0X20				;
			subwf		TEMP_1,f			;
			clrf		PCLATH				;
			movlw		.5					;
			movwf		Temp_ind			;
			movlw		HIGH ASCII			;
			movwf		PCLATH				;
			movf		Temp_ind,w			;
			sublw		.5					;
			movwf		TEMP				;
			movf		TEMP_1,w			;
			call		ASCII				;
			clrf		PCLATH				;
			call		lcdta				;
			decfsz		Temp_ind,f			;
			goto		$-.10				;
			movlw		0x00				;
			call		lcdta				;
			return							;
;--------------------------------------------
Privet										;
			movlw		.35					;
			movwf		Temp_ind			;
			movf		Temp_ind,W			;  Privet 
			sublw		.35					;
			call		Privet_text			;
			call		lcdta				;
			decfsz		Temp_ind,F			;
			goto		$-5					;
			return							;
;-----------***RDA5807---------
RED_RDA5807									;
			CALL		I2CSTART			;
											;
			movlw		0x21				;  
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0A_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0A_L			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0B_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0B_L			;
			CALL		I2CsetNoACK			;
											;
			CALL		I2CSTOP				;
			return							;
;--------------------------------------------
;-----------***RDA5807---------
RED_RDA5807_1								;
			CALL		I2CSTART			;
											;
			movlw		0x21				;  
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0A_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0A_L			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0B_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_0B_L			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSA_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSA_L			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSB_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSB_L			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSC_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSC_L			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSD_H			;
			CALL		I2CsetACK 			;
											;
			CALL		I2CtoW				;
			MOVWF		I2C_data			;
			movwf		REG_RDSD_L			;
			CALL		I2CsetNoACK			;
											;
			CALL		I2CSTOP				;
			return							;
;-----------**--------
WRIT_VOL									;
			CALL		I2CSTART			;
											;
			movlw		WRITE_ADDR_FREQ		;  
			CALL		WtoI2C				;
			CALL		I2CgetACK			; 
											;
			movlw		0x05				;
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			movfw		REG_5H				;
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			movfw		REG_5L				;
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			CALL		I2CSTOP				;
			return							;
;-----------**---------------
WRIT_AVTOSCAN								;
			CALL		I2CSTART			;
											;
			movlw		0x20				;  
			CALL		WtoI2C				;
			CALL		I2CgetACK			; 
											;
			movlw		0xD3				;
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			movlw		0x8D				;
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			movfw		REG_3H				;
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			movfw		REG_3L				;
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			CALL		I2CSTOP				;
			return							;
;-----------******************
;--------***RDA5807-----------
WRIT_FREQ									;
			CALL		I2CSTART			;
											;
			movlw		WRITE_ADDR_FREQ		;  
			CALL		WtoI2C				;
			CALL		I2CgetACK			;
											;
			movlw		0x03				;
			CALL		WtoI2C				;
 			CALL		I2CgetACK			;
											;
			movfw		REG_3H				;
			CALL		WtoI2C				;
 			CALL		I2CgetACK			;
											;
			movfw		REG_3L				;
			CALL		WtoI2C				;
 			CALL		I2CgetACK			;
											;
			CALL		I2CSTOP				;
			return							;
;--------***RDA5807-----------
WRIT_RDA5807								;
			CALL		I2CSTART			;
											;
			movlw		WRITE_ADDR			;  
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			; 
											;
			movfw		REG_2H				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			movfw		REG_2L				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			movfw		REG_3H				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			movfw		REG_3L				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			movfw		REG_4H				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			movfw		REG_4L				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			movfw		REG_5H				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			movfw		REG_5L				;
			CALL 		WtoI2C				; 
			CALL		I2CgetACK			;
											;
			CALL		I2CSTOP				;
			return							;
;:::::::::::::::::2/10:::::::::::::::::::::::::
BINToBCD16_5								;
			swapf		BSDH,w				;w  = A2*16+A3
			andlw		0x0F				;w  = A3		*** PERSONALLY, I'D REPLACE THESE 2
			addlw		0xF0				;w  = A3-16	*** LINES WITH "IORLW b'11110000B' " -AW
			movwf		Thou				;B3 = A3-16
			addwf		Thou,f				;B3 = 2*(A3-16) = 2A3 - 32
			addlw		.226				;w  = A3-16 - 30 = A3-46
			movwf		Hund				;B2 = A3-46
			addlw		.50					;w  = A3-46 + 50 = A3+4
			movwf		Ones				;B0 = A3+4
											;
			movf		BSDH,w				;w  = A3*16+A2
			andlw		0x0F				;w  = A2
			addwf		Hund,f				;B2 = A3-46 + A2 = A3+A2-46
			addwf		Hund,f				;B2 = A3+A2-46  + A2 = A3+2A2-46
			addwf		Ones,f				;B0 = A3+4 + A2 = A3+A2+4
			addlw		.233				;w  = A2 - 23
			movwf		Tens				;B1 = A2-23
			addwf		Tens,f				;B1 = 2*(A2-23)
			addwf		Tens,f				;B1 = 3*(A2-23) = 3A2-69 (Doh! thanks NG)
											;
			swapf		BSDL,w				;w  = A0*16+A1
			andlw		0x0F				;w  = A1
			addwf		Tens,f				;B1 = 3A2-69 + A1 = 3A2+A1-69 range -69...-9
			addwf		Ones,f				;B0 = A3+A2+4 + A1 = A3+A2+A1+4 and Carry = 0 (thanks NG)
											;
			rlf			Tens,f				;B1 = 2*(3A2+A1-69) + C = 6A2+2A1-138 and Carry is now 1 as tens register had to be negitive
			rlf			Ones,f				;B0 = 2*(A3+A2+A1+4) + C = 2A3+2A2+2A1+9 (+9 not +8 due to the carry from prev line, Thanks NG)
			comf		Ones,f				;B0 = ~(2A3+2A2+2A1+9) = -2A3-2A2-2A1-10 (ones complement plus 1 is twos complement. Thanks SD)
											;
			rlf			Ones,f				;B0 = 2*(-2A3-2A2-2A1-10) = -4A3-4A2-4A1-20
											;
			movf		BSDL,w				;w  = A1*16+A0
			andlw		0x0F				;w  = A0
			addwf		Ones,f				;B0 = -4A3-4A2-4A1-20 + A0 = A0-4(A3+A2+A1)-20 range -215...-5 Carry=0
			rlf			Thou,f				;B3 = 2*(2A3 - 32) = 4A3 - 64
											;
			movlw		0x07				;w  = 7
			movwf		TenK				;B4 = 7
											;
			movlw		.10					;w  = 10
Lb1:										;do
			addwf		Ones,f				; B0 += 10
			decf		Tens,f				; B1 -= 1
			btfss		3,0					;
						 					;skip no carry
			goto		Lb1					; while B0 < 0
											;jmp carry
Lb2:										;do
			addwf		Tens,f				; B1 += 10
			decf		Hund,f				; B2 -= 1
			btfss		3,0					;
			goto		Lb2					; while B1 < 0
Lb3:										;do
			addwf		Hund,f				; B2 += 10
			decf		Thou,f				; B3 -= 1
			btfss		3,0					;
			goto		Lb3					; while B2 < 0
Lb4:										;do
			addwf		Thou,f				; B3 += 10
			decf		TenK,f				; B4 -= 1
			btfss		3,0					;
			goto		Lb4					; while B3 < 0 
											;
			RETURN							;
;*************LCD*NOKIA*5110**************************
;-----------**LCD---------------
LCD_INIT									;
			bsf			dorc				;
			bsf			enab				;
			call		lcres				; reset for 250 ms
			movlw		0x21				; extended set command
			call		lccmd				;
			movlw		0xC2				;Vop 
			call		lccmd				;
			movlw		0x06				;bias loop
			call		lccmd				;
			movlw		0x13				;vertical mode and normal set command
			call		lccmd				;
			movlw		0x20				;vertical mode and normal set command
			call		lccmd				;
			movlw		0x0C				;vertical mode and normal set command
			call		lccmd				;
			call		Eresh_LCD			;erase lcd
			call		delay_250ms			;
			movlw		0x80				;mod control normal 
			call		lccmd				;
			movlw		0x40				;x ini 
			call		lccmd				;
			return							;
;--------------------------------------------
pct											;
			movlw		0x98				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
lin1										;
			movlw		0x40				; linia 1
			call		lccmd				;
			return							;
;--------------------------------------------
lin2										;
			movlw		0x41				; linia 2
			call		lccmd				;
			return							;
;--------------------------------------------
lin3										;
			movlw		0x42				; linia 3
			call		lccmd				;
			return							;
;--------------------------------------------
lin4										;
			movlw		0x43				; linia 4
			call		lccmd				;
			return							;
;--------------------------------------------
lin5										;
			movlw		0x44				; linia 5
			call		lccmd				;
			return							;
;--------------------------------------------
lin6										;
			movlw		0x45				; linia 6
			call		lccmd				;
			return							;
;--------------------------------------------
poz0										;
			movlw		0x80				; punct
			call		lccmd				;
			return 							;
;--------------------------------------------
poz1										;
			movlw		0x85				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz2										;
			movlw		0x8B				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz3										;
			movlw		0x91				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz4										;
			movlw		0x97				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz5										;
			movlw		0x9D				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz6										;
			movlw		0xA3				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz7										;
			movlw		0xA9				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz8										;
			movlw		0xAF				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz9										;
			movlw		0xB5				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz10										;
			movlw		0xBB				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz11										;
			movlw		0xC1				; punct
			call		lccmd 				;
			return							;
;--------------------------------------------
poz12										;
			movlw		0xC7				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz13										;
			movlw		0xCD				; punct
			call		lccmd				;
			return							;
;--------------------------------------------
poz14										;
			movlw		0xD3				; punct
			call		lccmd				;
			return							;
;-----------***LCD------------
lcdta										;
			bsf			dorc				; lcd data
			bcf			enab				; lcd enable
			call		varsa				;
			bsf			enab				;
			return							;
;-----------***LCD------------
lccmd										;
			bcf			dorc				; lcd command
			bcf			enab				; lcd enable
			call		varsa				;
			bsf			enab				;
			return							;
;-----------*LCD-----------------
lcres										;
			bcf			rset				; reset
			call		delay_250ms			;
			bsf			rset				; dezactivare reset
			return							;
;-----------***LCD--------
varsa										;
			movwf		afisaj				;
			movlw		0x08				;
			movwf		count4				;
vbit										;
			bcf			sclk				;
			btfsc		afisaj,7			;bit0
			bsf			sdta				;
			btfss		afisaj,7			;
			bcf			sdta				;
			nop								;
			nop								;
			nop								;
			bsf			sclk				;
			nop								;
			nop								;
			nop								;
			rlf			afisaj,1			;
			decfsz		count4,F			;
			goto		vbit				;
			return							;
;-----------*LCD----------------------
Eresh_LCD									;
			bcf			sdta				; data it is null for clearing
			movlw		0x06				; 6 lines
			movwf		count3				;
c3											;
			movlw		0x54				; 84 coloane
			movwf		count1				;
c1											;
			movlw		0x08				; one bytes it is send with 8 clock pulse
			movwf		count2				;
			bsf			dorc				;
			bcf			enab				;
c2											;
			bcf			sclk				;
			nop								;
			nop								;
			bsf			sclk				;
			decfsz		count2,F			;
			goto		c2					;
			bsf			enab				;
			decfsz		count1,F			;
			goto		c1					;
			decfsz		count3,F			;
			goto		c3					;
			return							;
;***********I2C****************************************
;--------------------------------------------
I2CSTART									;
			BSF			SCL					;
			BSF			SDA					;
			CALL		Tempo5us			;
			BCF			SDA					;
			CALL		Tempo5us			;
			BCF			SCL					;
			CALL		Tempo5us			;
			BSF			SDA					;
			RETURN							;
;--------------------------------------------
I2CSTOP										;
			BCF			SCL					;
			BCF			SDA					;
			CALL		Tempo5us			;
			BSF			SCL					;
			CALL		Tempo5us			;
			BSF			SDA					;
			CALL		Tempo5us			;
			RETURN							;
;--------------------------------------------
WtoI2C										;
			MOVWF		VAR1				;
			MOVLW		8					;
			MOVWF		VAR2				;
NextBitI2Cout								;
			BCF			SCL					;
			BTFSS		VAR1,7				;
			BCF			SDA					;
			BTFSC		VAR1,7				;
			BSF			SDA					;
			CALL		Tempo5us			;
			BSF			SCL					;
			CALL		Tempo5us			;
			BCF			SCL					;
			RLF			VAR1,F				;
			DECFSZ		VAR2,F				;
			GOTO		NextBitI2Cout		;
			BSF			SDA					;
			RETURN							;
;--------------------------------------------
I2CtoW										;
			MOVLW		8					;
			MOVWF		VAR2				;
			CLRF		VAR1				;
			bsf			STATUS,RP0			;
			bsf			TRISA_SDA			;
			bcf			STATUS,RP0			;
NextBitI2Cin								;
			BCF			SCL					;
			CALL		Tempo5us			;
			BSF			SCL					;
			CALL		Tempo5us			;
			RLF			VAR1,F				;
			BCF			VAR1,0				;
			BTFSC		SDA					;
			BSF			VAR1,0				;
			DECFSZ		VAR2,F				;
			GOTO		NextBitI2Cin		;
			bsf			STATUS,RP0			;
			bcf			TRISA_SDA			;
			bcf			STATUS,RP0			;
			BCF			SCL					;
			MOVF		VAR1,W				;
			RETURN							;
;--------------------------------------------
I2CgetACK									;
			bsf			STATUS,RP0			;
			bsf			TRISA_SDA			;
			bcf			STATUS,RP0			;
			BCF			SCL					;
			CALL		Tempo5us			;
			BSF			SCL					;
			CALL		Tempo5us			;
			BCF			BOOLEEN,I2CACK		;
			BTFSS		SDA					;
			BSF			BOOLEEN,I2CACK		;
			bsf			STATUS,RP0			;
			bcf			TRISA_SDA			;
			bcf			STATUS,RP0			;
			BCF			SCL					;
			RETURN							;
;--------------------------------------------
I2CsetACK									;
			BCF			SCL					;
			BCF			SDA					;
			CALL		Tempo5us			;
			BSF			SCL					;
			CALL		Tempo5us			;
			BCF			SCL					;
			BSF			SDA					;
			RETURN							;
;--------------------------------------------
I2CsetNoACK									;
			BCF			SCL					;
			BSF			SDA					;
			CALL		Tempo5us			;
			BSF			SCL					;
			CALL		Tempo5us			;
			BCF			SCL					;
			RETURN							;
;*********EEPROM**************************************
;--------**EEPROM--------------------
EERED										;
			banksel		EEADR				;   2- .
			movf		Temp_ADDR,w 		;   EEPROM
			movwf		EEADR				;  
			BANKSEL		EECON1				;
			BCF			EECON1,EEPGD		;
			BSF			EECON1,RD			;
			BANKSEL		EEDATA				;
			MOVF		EEDATA,W			; 
			banksel		0					;   0- 
			return							; 
;--------**EEPROM---------------------
WRITE_ERR									;
			banksel		EEADR				;   2- .
			movf		Temp_ADDR,w			;   EEPROM
			movwf		EEADR				;   00h.
			movf		Temp_EEDAT,W		;   
			movwf		EEDATA				;    -> EEData.
			banksel		EECON1				;   3- .
			BCF			EECON1,EEPGD		;   EEPROM.
			BSF			EECON1,WREN			;  .
			movlw		0x55				; 
			movwf		EECON2				; 
			movlw		0xAA				; 
			movwf		EECON2				; .
			bsf			EECON1,WR			;  .
			BSF			EECON1,WREN			;  .
			btfsc		EECON1,WR			;     ?
			goto		$-1					;   ,  "" .
			banksel		0 					;  ,      0- .
			return							; 
;****************************************************
;----------- 500 ms------------------
delay_500ms									;
			movlw		0x0B				;
			movwf		TAIM_H				;
			movlw		0xDD				;
			movwf		TAIM_L				;
			goto		delay				;
;--------------------------------------------
delay_250ms									;
			movlw		0x85				;
			movwf		TAIM_H				;
			movlw		0xEF				;
			movwf		TAIM_L				;
			goto		delay				;
;----------- 100 ms------------------
delay_100ms									;
			movlw		0xCF				;
			movwf		TAIM_H				;
			movlw		0x2D				;
			movwf		TAIM_L				;
			goto		delay				;
;-----------*35ms--------------------
delay										;
			btfsc		PIR1,0				;
			bcf			PIR1,0				;
			movfw		TAIM_H				;
			movwf		TMR1H				;
			movfw		TAIM_L				;
			movwf		TMR1L				; 
			bsf			T1CON,0				;
			btfss		PIR1,0				;
			goto		$-1					;
			bcf			PIR1,0				;
			return							; 
;--------------------------------------------
Tempo5us									;
			NOP								;
			NOP								;
			NOP								;
			NOP								;
			NOP								;
			RETURN							;
;************************************************************
			org			800h				;   2 
;--------------------------------------------
Cifra_med									;
			addwf		PCL,f				;
			goto		CIF_0_med			;
			goto		CIF_1_med			;
			goto		CIF_2_med			;
			goto		CIF_3_med			;
			goto		CIF_4_med			;
			goto		CIF_5_med			;
			goto		CIF_6_med			;
			goto		CIF_7_med			;
			goto		CIF_8_med			;
			goto		CIF_9_med			;
;--------------------------------------------
CIF_0_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0xfc,0x7a,0x06,0x06,0x06,0x06,0x06,0x06,0x7a,0xfc,0x00,0x00,0x7e,0xbc,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xbc,0x7e,0x00 ; 0
;-------------------------------------------
CIF_1_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
 			DT	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3c,0x7e,0x00 ; 1
;--------------------------------------------
CIF_2_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0x00,0x02,0x86,0x86,0x86,0x86,0x86,0x86,0x7a,0xfc,0x00,0x00,0x7e,0xbd,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0x81,0x00, 0x00 ; 2
;--------------------------------------------
CIF_3_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0x00,0x02,0x86,0x86,0x86,0x86,0x86,0x86, 0x7a,0xfc,0x00,0x00,0x00,0x81,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0xbd,0x7e,0x00 ; 3
;--------------------------------------------
CIF_4_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0xfc,0x78,0x80,0x80,0x80,0x80,0x80,0x80,0x78,0xfc,0x00,0x00,0x00,0x01,0x03,0x03,0x03,0x03,0x03,0x03,0x3d,0x7e,0x00 ; 4
;--------------------------------------------
CIF_5_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0xfc,0x7a,0x86,0x86,0x86,0x86,0x86,0x86,0x02,0x00,0x00,0x00,0x00,0x81,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0xbd,0x7e,0x00 ; 5
;--------------------------------------------
CIF_6_med									;
			movf		TEMP,W				;
			addwf		PCL,F				;
			DT	0x00,0xfc,0x7a,0x86,0x86,0x86,0x86,0x86,0x86,0x02,0x00,0x00,0x00,0x7e,0xbd,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0xbd,0x7e,0x00 ; 6
;--------------------------------------------
CIF_7_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0x00,0x02,0x06,0x06,0x06,0x06,0x06,0x06,0x7a,0xfc,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3c,0x7e,0x00 ; 7
;--------------------------------------------
CIF_8_med									;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0xfc,0x7a,0x86,0x86,0x86,0x86,0x86,0x86,0x7a,0xfc,0x00,0x00,0x7e,0xbd,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0xbd,0x7e,0x00 ; 8
;--------------------------------------------
			ORG			900H				;    
;--------------------------------------------
CIF_9_med									;
			movlw		HIGH CIF_9_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0xfc,0x7a,0x86,0x86,0x86,0x86,0x86,0x86,0x7a,0xfc,0x00,0x00,0x00,0x81,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0xbd,0x7e,0x00 ; 9
;--------------------------------------------
TOCHKA_med									;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc0,0xc0,0x00,0x00,0x00,0x00,0x00 ; .
;--------------------------------------------
Cifra										;
			addwf		PCL,f				;
			goto		CIF_0				;
			goto		CIF_1				;
			goto		CIF_2				;
			goto		CIF_3				;
			goto		CIF_4				;
			goto		CIF_5				;
			goto		CIF_6				;
			goto		CIF_7				;
			goto		CIF_8				;
			goto		CIF_9				;
			goto		TOCHKA				;
;--------------------------------------------
CIF_0										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT 0x3E,0x51,0x49,0x45,0x3E,0x00 ;
;--------------------------------------------
CIF_1										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
  			DT 0x00,0x42,0x7F,0x40,0x00,0x00 ;
;--------------------------------------------
CIF_2										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
 		  	DT 0x42,0x61,0x51,0x49,0x46,0x00 ;
;-------------------------------------------
CIF_3										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT 0x21,0x41,0x45,0x4B,0x31,0x00 ;
;-------------------------------------------
CIF_4										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   			DT 0x18,0x14,0x12,0x7F,0x10,0x00 ;
;--------------------------------------------
CIF_5										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
  			DT 0x27,0x45,0x45,0x45,0x39,0x00 ;
;--------------------------------------------
CIF_6										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
  			DT 0x3C,0x4A,0x49,0x49,0x30,0x00 ;
;--------------------------------------------
CIF_7										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   			DT 0x01,0x71,0x09,0x05,0x03,0x00 ;
;--------------------------------------------
CIF_8										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   			DT	 0x36,0x49,0x49,0x49,0x36,0x00 ;
;--------------------------------------------
CIF_9										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   			DT 0x06,0x49,0x49,0x29,0x1E,0x00 ;
;--------------------------------------------
TOCHKA										;
			movlw		HIGH TOCHKA_med		;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
			DT	0x00,0x00,0xc0,0xc0,0x00,0x00	;
;--------------------------------------------
			ORG		0xA00					;
;--------------------------------------------
ASCII										;
			addwf		PCL,f				;
			goto		SIM_20				;
			goto		SIM_21				;
			goto		SIM_22				;
			goto		SIM_23				;
			goto		SIM_24				;
			goto		SIM_25				;
			goto		SIM_26				;
			goto		SIM_27				;
			goto		SIM_28				;
			goto		SIM_29				;
			goto		SIM_2A				;
			goto		SIM_2B				;
			goto		SIM_2C				;
			goto		SIM_2D				;
			goto		SIM_2E				;
			goto		SIM_2F				;
			goto		SIM_30				;
			goto		SIM_31				;
			goto		SIM_32				;
			goto		SIM_33				;
			goto		SIM_34				;
			goto		SIM_35				;
			goto		SIM_36				;
			goto		SIM_37				;
			goto		SIM_38				;
			goto		SIM_39				;
			goto		SIM_3A				;
			goto		SIM_3B				;
			goto		SIM_3C				;
			goto		SIM_3D				;
			goto		SIM_3E				;
			goto		SIM_3F				;
			goto		SIM_40				;
			goto		SIM_41				;
			goto		SIM_42				;
			goto		SIM_43				;
			goto		SIM_44				;
			goto		SIM_45				;
			goto		SIM_46				;
			goto		SIM_47				;
			goto		SIM_48				;
			goto		SIM_49				;
			goto		SIM_4A				;
			goto		SIM_4B				;
			goto		SIM_4C				;
			goto		SIM_4D				;
			goto		SIM_4E				;
			goto		SIM_4F				;
			goto		SIM_50				;
			goto		SIM_51				;
			goto		SIM_52				;
			goto		SIM_53				;
			goto		SIM_54				;
			goto		SIM_55				;
			goto		SIM_56				;
			goto		SIM_57				;
			goto		SIM_58				;
			goto		SIM_59				;
			goto		SIM_5A				;
			goto		SIM_5B				;
			goto		SIM_5C				;
			goto		SIM_5D				;
			goto		SIM_5E				;
			goto		SIM_5F				;
			goto		SIM_60				;
			goto		SIM_61				;
			goto		SIM_62				;
			goto		SIM_63				;
			goto		SIM_64				;
			goto		SIM_65				;
			goto		SIM_66				;
			goto		SIM_67				;
			goto		SIM_68				;
			goto		SIM_69				;
			goto		SIM_6A				;
			goto		SIM_6B				;
			goto		SIM_6C				;
			goto		SIM_6D				;
			goto		SIM_6E				;
			goto		SIM_6F				;
			goto		SIM_70				;
			goto		SIM_71				;
			goto		SIM_72				;
			goto		SIM_73				;
			goto		SIM_74				;
			goto		SIM_75				;
			goto		SIM_76				;
			goto		SIM_77				;
			goto		SIM_78				;
			goto		SIM_79				;
			goto		SIM_7A				;
			goto		SIM_7B				;
			goto		SIM_7C				;
			goto		SIM_7D				;
			goto		SIM_7E				;
			goto		SIM_7F				;
;--------------------------------------------
			ORG			0xB00				;    
;--------------------------------------------
SIM_20										;
			movlw		HIGH SIM_20			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
	DT 0x00, 0x00, 0x00, 0x00, 0x00 ;},   //   0x20  32 1
SIM_21										;
			movlw		HIGH SIM_21			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x00, 0x5F, 0x00, 0x00 ;},   // ! 0x21  33	2
SIM_22										;
			movlw		HIGH SIM_22			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x07, 0x00, 0x07, 0x00 ;},   // " 0x22  34	3
SIM_23										;
			movlw		HIGH SIM_23			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x14, 0x7F, 0x14, 0x7F, 0x14 ;},   // # 0x23  35	4
SIM_24										;
			movlw		HIGH SIM_24			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x24, 0x2A, 0x7F, 0x2A, 0x12 ;},   // $ 0x24  36	5
SIM_25										;
			movlw		HIGH SIM_25			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x4C, 0x2C, 0x10, 0x68, 0x64 ;},   // % 0x25  37	6
SIM_26										;
			movlw		HIGH SIM_26			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x36, 0x49, 0x55, 0x22, 0x50 ;},   // & 0x26  38	7
SIM_27										;
			movlw		HIGH SIM_27			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x05, 0x03, 0x00, 0x00 ;},   // ' 0x27  39	8
SIM_28										;
			movlw		HIGH SIM_28			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x1C, 0x22, 0x41, 0x00 ;},   // ( 0x28  40	9
SIM_29										;
			movlw		HIGH SIM_29			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x41, 0x22, 0x1C, 0x00 ;},   // ) 0x29  41	10
SIM_2A										;
			movlw		HIGH SIM_2A			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x14, 0x08, 0x3E, 0x08, 0x14 ;},   // * 0x2A  42	11
SIM_2B										;
			movlw		HIGH SIM_2B			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x08, 0x08, 0x3E, 0x08, 0x08 ;},   // + 0x2B  43	12
SIM_2C										;
			movlw		HIGH SIM_2C			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x00, 0x50, 0x30, 0x00 ;},   // , 0x2C  44	13
SIM_2D										;
			movlw		HIGH SIM_2D			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x10, 0x10, 0x10, 0x10, 0x10 ;},   // - 0x2D  45	14
SIM_2E										;
			movlw		HIGH SIM_2E			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x60, 0x60, 0x00, 0x00 ;},   // . 0x2E  46	15
SIM_2F										;
			movlw		HIGH SIM_2F			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x20, 0x10, 0x08, 0x04, 0x02 ;},   // / 0x2F  47	16
SIM_30										;
			movlw		HIGH SIM_30			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3E, 0x51, 0x49, 0x45, 0x3E ;},   // 0 0x30  48	17
SIM_31										;
			movlw		HIGH SIM_31			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x42, 0x7F, 0x40, 0x00 ;},   // 1 0x31  49	18
SIM_32										;
			movlw		HIGH SIM_32			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x42, 0x61, 0x51, 0x49, 0x46 ;},   // 2 0x32  50	19
SIM_33										;
			movlw		HIGH SIM_33			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x21, 0x41, 0x45, 0x4B, 0x31 ;},   // 3 0x33  51	20
SIM_34										;
			movlw		HIGH SIM_34			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x18, 0x14, 0x12, 0x7F, 0x10 ;},   // 4 0x34  52	21
SIM_35										;
			movlw		HIGH SIM_35			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x27, 0x45, 0x45, 0x45, 0x39 ;},   // 5 0x35  53	22
SIM_36										;
			movlw		HIGH SIM_36			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3C, 0x4A, 0x49, 0x49, 0x30 ;},   // 6 0x36  54	23
SIM_37										;
			movlw		HIGH SIM_37			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x01, 0x71, 0x09, 0x05, 0x03 ;},   // 7 0x37  55	24
SIM_38										;
			movlw		HIGH SIM_38			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x36, 0x49, 0x49, 0x49, 0x36 ;},   // 8 0x38  56	25
SIM_39										;
			movlw		HIGH SIM_39			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x06, 0x49, 0x49, 0x29, 0x1E ;},   // 9 0x39  57	26
SIM_3A										;
			movlw		HIGH SIM_3A			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x36, 0x36, 0x00, 0x00 ;},   // : 0x3A  58	27
SIM_3B										;
			movlw		HIGH SIM_3B			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x56, 0x36, 0x00, 0x00 ;},   // ; 0x3B  59	28
;--------------------------------------------
			ORG			0xC00				;    
;--------------------------------------------
SIM_3C										;
			movlw		HIGH SIM_3C			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x08, 0x14, 0x22, 0x41, 0x00 ;},   // < 0x3C  60	29
SIM_3D										;
			movlw		HIGH SIM_3D			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x14, 0x14, 0x14, 0x14, 0x14 ;},   // = 0x3D  61	30
SIM_3E										;
			movlw		HIGH SIM_3E			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x41, 0x22, 0x14, 0x08 ;},   // > 0x3E  62	31
SIM_3F										;
			movlw		HIGH SIM_3F			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x02, 0x01, 0x51, 0x09, 0x06 ;},   // ? 0x3F  63	32
SIM_40										;
			movlw		HIGH SIM_40			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x32, 0x49, 0x79, 0x41, 0x3E ;},   // @ 0x40  64	33
SIM_41										;
			movlw		HIGH SIM_41			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7E, 0x11, 0x11, 0x11, 0x7E ;},   // A 0x41  65	34
SIM_42										;
			movlw		HIGH SIM_42			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x49, 0x49, 0x49, 0x36 ;},   // B 0x42  66	35
SIM_43										;
			movlw		HIGH SIM_43			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3E, 0x41, 0x41, 0x41, 0x22 ;},   // C 0x43  67	36
SIM_44										;
			movlw		HIGH SIM_44			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x41, 0x41, 0x22, 0x1C ;},   // D 0x44  68	37
SIM_45										;
			movlw		HIGH SIM_45			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x49, 0x49, 0x49, 0x41 ;},   // E 0x45  69	38
SIM_46										;
			movlw		HIGH SIM_46			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x09, 0x09, 0x09, 0x01 ;},   // F 0x46  70	39
SIM_47										;
			movlw		HIGH SIM_47			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3E, 0x41, 0x49, 0x49, 0x7A ;},   // G 0x47  71	40
SIM_48										;
			movlw		HIGH SIM_48			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x08, 0x08, 0x08, 0x7F ;},   // H 0x48  72	41
SIM_49										;
			movlw		HIGH SIM_49			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x41, 0x7F, 0x41, 0x00 ;},   // I 0x49  73	42
SIM_4A										;
			movlw		HIGH SIM_4A			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x20, 0x40, 0x41, 0x3F, 0x01 ;},   // J 0x4A  74	43
SIM_4B										;
			movlw		HIGH SIM_4B			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x08, 0x14, 0x22, 0x41 ;},   // K 0x4B  75	44
SIM_4C										;
			movlw		HIGH SIM_4C			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x40, 0x40, 0x40, 0x40 ;},   // L 0x4C  76	45
SIM_4D										;
			movlw		HIGH SIM_4D			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x02, 0x0C, 0x02, 0x7F ;},   // M 0x4D  77	46
SIM_4E										;
			movlw		HIGH SIM_4E			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x04, 0x08, 0x10, 0x7F ;},   // N 0x4E  78	47
SIM_4F										;
			movlw		HIGH SIM_4F			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3E, 0x41, 0x41, 0x41, 0x3E ;},   // O 0x4F  79	48
SIM_50										;
			movlw		HIGH SIM_50			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x09, 0x09, 0x09, 0x06 ;},   // P 0x50  80	49
SIM_51										;
			movlw		HIGH SIM_51			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3E, 0x41, 0x51, 0x21, 0x5E ;},   // Q 0x51  81	50
SIM_52										;
			movlw		HIGH SIM_52			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x09, 0x19, 0x29, 0x46 ;},   // R 0x52  82	51
SIM_53										;
			movlw		HIGH SIM_53			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x46, 0x49, 0x49, 0x49, 0x31 ;},   // S 0x53  83	52
SIM_54										;
			movlw		HIGH SIM_54			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x01, 0x01, 0x7F, 0x01, 0x01 ;},   // T 0x54  84	53
SIM_55										;
			movlw		HIGH SIM_55			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3F, 0x40, 0x40, 0x40, 0x3F ;},   // U 0x55  85	54
SIM_56										;
			movlw		HIGH SIM_56			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x1F, 0x20, 0x40, 0x20, 0x1F ;},   // V 0x56  86	55
SIM_57										;
			movlw		HIGH SIM_57			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3F, 0x40, 0x38, 0x40, 0x3F ;},   // W 0x57  87	56
;--------------------------------------------
			ORG			0xD00				;    
;--------------------------------------------
SIM_58										;
			movlw		HIGH SIM_58			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x63, 0x14, 0x08, 0x14, 0x63 ;;},   // X 0x58  88	57
SIM_59										;
			movlw		HIGH SIM_59			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x07, 0x08, 0x70, 0x08, 0x07 ;},   // Y 0x59  89	58
SIM_5A										;
			movlw		HIGH SIM_5A			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x61, 0x51, 0x49, 0x45, 0x43 ;},   // Z 0x5A  90	59
SIM_5B										;
			movlw		HIGH SIM_5B			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x7F, 0x41, 0x41, 0x00 ;},   // [ 0x5B  91	60
SIM_5C										;
			movlw		HIGH SIM_5C			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x02, 0x04, 0x08, 0x10, 0x20 ;},   // \ 0x5C  92	61
SIM_5D										;
			movlw		HIGH SIM_5D			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x41, 0x41, 0x7F, 0x00 ;},   // ] 0x5D  93	62
SIM_5E										;
			movlw		HIGH SIM_5E			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x04, 0x02, 0x01, 0x02, 0x04 ;},   // ^ 0x5E  94	63
SIM_5F										;
			movlw		HIGH SIM_5F			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x40, 0x40, 0x40, 0x40, 0x40 ;},   // _ 0x5F  95	64
SIM_60										;
			movlw		HIGH SIM_60			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x01, 0x02, 0x04, 0x00 ;},   // ` 0x60  96	65
SIM_61										;
			movlw		HIGH SIM_61			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x20, 0x54, 0x54, 0x54, 0x78 ;},   // a 0x61  97	66
SIM_62										;
			movlw		HIGH SIM_62			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x48, 0x44, 0x44, 0x38 ;},   // b 0x62  98	67
SIM_63										;
			movlw		HIGH SIM_63			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x38, 0x44, 0x44, 0x44, 0x20 ;},   // c 0x63  99	68
SIM_64										;
			movlw		HIGH SIM_64			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x38, 0x44, 0x44, 0x48, 0x7F ;},   // d 0x64 100	69
SIM_65										;
			movlw		HIGH SIM_65			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x38, 0x54, 0x54, 0x54, 0x18 ;},   // e 0x65 101	70
SIM_66										;
			movlw		HIGH SIM_66			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x08, 0x7E, 0x09, 0x01, 0x02 ;},   // f 0x66 102	71
SIM_67										;
			movlw		HIGH SIM_67			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x0C, 0x52, 0x52, 0x52, 0x3E ;},   // g 0x67 103	72
SIM_68										;
			movlw		HIGH SIM_68			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x08, 0x04, 0x04, 0x78 ;},   // h 0x68 104	73
SIM_69										;
			movlw		HIGH SIM_69			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x44, 0x7D, 0x40, 0x00 ;},   // i 0x69 105	74
SIM_6A										;
			movlw		HIGH SIM_6A			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x20, 0x40, 0x44, 0x3D, 0x00 ;},   // j 0x6A 106	75
SIM_6B										;
			movlw		HIGH SIM_6B			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7F, 0x10, 0x28, 0x44, 0x00 ;},   // k 0x6B 107	76
SIM_6C										;
			movlw		HIGH SIM_6C			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x41, 0x7F, 0x40, 0x00 ;},   // l 0x6C 108	77
SIM_6D										;
			movlw		HIGH SIM_6D			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7C, 0x04, 0x18, 0x04, 0x78 ;},   // m 0x6D 109	78
SIM_6E										;
			movlw		HIGH SIM_6E			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7C, 0x08, 0x04, 0x04, 0x78 ;},   // n 0x6E 110	79
SIM_6F										;
			movlw		HIGH SIM_6F			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x38, 0x44, 0x44, 0x44, 0x38 ;},   // o 0x6F 111	80
SIM_70										;
			movlw		HIGH SIM_70			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7C, 0x14, 0x14, 0x14, 0x08 ;},   // p 0x70 112	81
SIM_71										;
			movlw		HIGH SIM_71			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x08, 0x14, 0x14, 0x18, 0x7C ;},   // q 0x71 113	82
SIM_72										;
			movlw		HIGH SIM_72			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x7C, 0x08, 0x04, 0x04, 0x08 ;},   // r 0x72 114	83
SIM_73										;
			movlw		HIGH SIM_73			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x48, 0x54, 0x54, 0x54, 0x20 ;},   // s 0x73 115	83
;--------------------------------------------
			ORG			0xE00				;    
;--------------------------------------------
SIM_74										;
			movlw		HIGH SIM_74			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x04, 0x3F, 0x44, 0x40, 0x20 ;},   // t 0x74 116	84
SIM_75										;
			movlw		HIGH SIM_75			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3C, 0x40, 0x40, 0x20, 0x7C ;},   // u 0x75 117	85
SIM_76										;
			movlw		HIGH SIM_76			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x1C, 0x20, 0x40, 0x20, 0x1C ;},   // v 0x76 118	86
SIM_77										;
			movlw		HIGH SIM_77			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x3C, 0x40, 0x30, 0x40, 0x3C ;},   // w 0x77 119	87
SIM_78										;
			movlw		HIGH SIM_78			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x44, 0x28, 0x10, 0x28, 0x44 ;},   // x 0x78 120	88
SIM_79										;
			movlw		HIGH SIM_79			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x0C, 0x50, 0x50, 0x50, 0x3C ;},   // y 0x79 121	89
SIM_7A										;
			movlw		HIGH SIM_7A			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x44, 0x64, 0x54, 0x4C, 0x44 ;},   // z 0x7A 122	90
SIM_7B										;
			movlw		HIGH SIM_7B			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x08, 0x36, 0x41, 0x00 ;},   // { 0x7B 123	91
SIM_7C										;
			movlw		HIGH SIM_7C			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x00, 0x7F, 0x00, 0x00 ;},   // | 0x7C 124	92
SIM_7D										;
			movlw		HIGH SIM_7D			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x00, 0x41, 0x36, 0x08, 0x00 ;},   // } 0x7D 125	93
SIM_7E										;
			movlw		HIGH SIM_7E			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0x08, 0x04, 0x08, 0x10, 0x08 ;},   // ~ 0x7E 126	94
SIM_7F										;
			movlw		HIGH SIM_7F			;
			movwf		PCLATH				;
			movf		TEMP,W				; 
			addwf		PCL,F				;
   DT 0xFF, 0xFF, 0xFF, 0xFF, 0xFF ;},   //  0x7F 127	95
;--------------------------------------------
											;
;************************************************************
			END								;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

